///////////////////////////////////////////////
//
// Track Bar
// Didier Robin Le 23-10-2002
//
//
/////////////////////////////////////////////////

#include "stdafx.h"
#include "resource.h"
#include <COMMCTRL.H>
#include <STREAMS.H>

#pragma comment(lib, "comctl32.lib")
INT_PTR CALLBACK DialogProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
long NotifyTrackBar(HWND hwndDlg, int nIDCtrl, LPNMHDR pNMHDR);

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
   INITCOMMONCONTROLSEX icc = { 0 };
   icc.dwSize = sizeof(INITCOMMONCONTROLSEX);
   icc.dwICC = ICC_TREEVIEW_CLASSES;

   BOOL bRet = InitCommonControlsEx(&icc);
   DialogBox(hInstance, MAKEINTRESOURCE(IDD_DIALOG), NULL, (DLGPROC) DialogProc);
   return 0;
}



INT_PTR CALLBACK DialogProc(HWND hWndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
   switch (uMsg)
   {
   case WM_COMMAND:
      switch (LOWORD(wParam))
      {
      case IDOK:
         EndDialog(hWndDlg, IDOK);
         break;
      case IDCANCEL:
         EndDialog(hWndDlg, IDCANCEL);
         break;
      }
      break;
   case WM_INITDIALOG:
      {
         HWND hWndTrackBar = GetDlgItem(hWndDlg, IDC_TRACK);
		 SetWindowLongPtr(hWndTrackBar,GWL_STYLE,GetWindowLongPtr(hWndTrackBar, GWL_STYLE) | TBS_FIXEDLENGTH);
		 SendDlgItemMessage(hWndDlg,IDC_TRACK, TBM_SETTHUMBLENGTH, 100, 0);
		 SendDlgItemMessage(hWndDlg,IDC_TRACK, TBM_SETRANGE, (WPARAM)FALSE, MAKELONG(0, 255));

      }
      return FALSE; 
     
   case WM_NOTIFY:
      {
        
         long lResult = NotifyTrackBar(hWndDlg, (int) wParam, (LPNMHDR) lParam);
         SetWindowLong(hWndDlg, DWL_MSGRESULT, lResult); 
         return TRUE;
      }
      break;
   }
   return FALSE;
}

long CustomDrawTrackBar(HWND hWndTrack, LPNMCUSTOMDRAW pNMTVCD)
{
	HBRUSH hbrush;
	HBRUSH hbOld;
	HPEN hpen;
	HPEN hpOld;
	LRESULT lResult;
	COLORREF crColor;

   if (pNMTVCD==NULL)
   {
      return -1;
   }
   switch (pNMTVCD->dwDrawStage)
   { 
      case CDDS_PREPAINT:
         return (CDRF_NOTIFYPOSTPAINT | CDRF_NOTIFYITEMDRAW);
   }

   	if ( pNMTVCD->dwDrawStage == CDDS_ITEMPREPAINT )
	{
		if ( pNMTVCD->dwItemSpec == TBCD_CHANNEL )
		{
			hbrush = CreateSolidBrush(0x0080FFFF);
			InflateRect(&pNMTVCD->rc, 0,10);
			hbOld = (HBRUSH)SelectObject(pNMTVCD->hdc, hbrush);
			RoundRect(pNMTVCD->hdc,
				pNMTVCD->rc.left,
				pNMTVCD->rc.top,
				pNMTVCD->rc.right,
				pNMTVCD->rc.bottom,
				15,15);
			DeleteObject(hbrush);
		}
		if ( pNMTVCD->dwItemSpec == TBCD_THUMB )
		{
			lResult = SendDlgItemMessage(::GetParent(hWndTrack),IDC_TRACK, TBM_GETPOS,0,0);
			crColor = RGB(lResult, 50, 255 - lResult);
			hpen = CreatePen(PS_SOLID, 1, 0x0000FF00);
			hbrush = CreateSolidBrush(crColor);
			hbOld = (HBRUSH)SelectObject(pNMTVCD->hdc, hbrush);
			hpOld = (HPEN)SelectObject(pNMTVCD->hdc, hpen);
			Ellipse(pNMTVCD->hdc, pNMTVCD->rc.left, pNMTVCD->rc.top,
				pNMTVCD->rc.right, pNMTVCD->rc.bottom);
			SelectObject(pNMTVCD->hdc, hpOld);
			DeleteObject(hbrush);
			DeleteObject(hpen);
		}
		return CDRF_SKIPDEFAULT;
	}

	return 0;
}

long NotifyTrackBar(HWND hWndDlg, int nIDCtrl, LPNMHDR pNMHDR)
{
   if (nIDCtrl == IDC_TRACK && pNMHDR)
   {
      if (pNMHDR->code == NM_CUSTOMDRAW)
      {
         LPNMCUSTOMDRAW pNMTVCD = (LPNMCUSTOMDRAW) pNMHDR;
         HWND hWndTrack = pNMHDR->hwndFrom;

         return CustomDrawTrackBar(hWndTrack, pNMTVCD);
      }
   }
   return 0;
}

